Bug 746710 (CVE-2011-3631)

Summary: CVE-2011-3631 hardlink: Multiple integer overflows, when adding string lengths
Product: [Other] Security Response Reporter: Jan Lieskovsky <jlieskov>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED WONTFIX QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedKeywords: Security
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-06-10 10:58:05 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On: 746715    
Bug Blocks: 746750    

Description Jan Lieskovsky 2011-10-17 15:33:22 UTC
Multiple integer overflows, leading to heap-based buffer overflows were found in the way hardlink, the tool for consolidation of duplicate files via hardlinks performed string lengths concatenation in the calculation of the required memory space to be used. A remote attacker could provide a specially-crafted directory tree (with long directory and / or file names), and trick the local user into consolidating it, leading to hardlink executable crash, or, potentially arbitrary code execution with the privileges of the user running the hardlink executable.

References:
[1] http://www.openwall.com/lists/oss-security/2011/10/15/2
[2] https://bugs.gentoo.org/show_bug.cgi?id=387269
[3] http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=645516

Proposed patch (applied by the Owl Linux distribution):
[4] http://cvsweb.openwall.com/cgi/cvsweb.cgi/Owl/packages/hardlink/hardlink.c.diff?r1=1.2;r2=1.3

Comment 1 Jan Lieskovsky 2011-10-17 15:39:30 UTC
These issues affect the versions of the hardlink package, as shipped with Fedora release of 14 and 15. Please schedule an update.

Comment 2 Jan Lieskovsky 2011-10-17 15:41:57 UTC
Created hardlink tracking bugs for this issue

Affects: fedora-all [bug 746715]

Comment 3 Jan Lieskovsky 2011-10-17 16:49:59 UTC
These issues affect the versions of the hardlink package, as shipped with
Red Hat Enterprise Linux 5 and 6.

Comment 4 Jan Lieskovsky 2011-10-20 15:45:53 UTC
The CVE identifier of CVE-2011-3631 has been assigned to this issue:
[5] http://www.openwall.com/lists/oss-security/2011/10/20/6

Comment 7 Fedora Update System 2011-11-23 23:27:47 UTC
hardlink-1.0-12.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2011-12-11 21:50:02 UTC
hardlink-1.0-12.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.